--- item.php	2009-04-11 20:18:28.000000000 +0200
+++ item.new.php	2009-07-23 22:49:50.000000000 +0200
@@ -105,7 +105,7 @@ function create_image($item, $mask_color
 	if($fgFile!='') {
 		$fg = load_image(IMAGE_PATH.$fgFile, $fgColor, $mask_color);
 		if($fg!==false){
-			imagecopy($bg, $fg, 0, 0, 0, 0, 40, 40);
+			draw_image($bg, $fg);
 			imagedestroy($fg);
 		}
 	}
@@ -113,7 +113,7 @@ function create_image($item, $mask_color
 	if($i1File!=''){
 		$im=load_image(IMAGE_PATH.$i1File, $i1Color, $mask_color);
 		if($im!==false){
-			imagecopy($bg, $im, 0, 0, 0, 0, 40, 40);
+			draw_image($bg, $im);
 			imagedestroy($im);
 		}
 	}
@@ -121,7 +121,7 @@ function create_image($item, $mask_color
 	if($i2File!=''){
 		$im=load_image(IMAGE_PATH.$i2File, $i2Color);
 		if($im!==false){
-			imagecopy($bg, $im, 0, 0, 0, 0, 40, 40);
+			draw_image($bg, $im);
 			imagedestroy($im);
 		}
 	}
@@ -180,6 +180,20 @@ function load_image($fileName, $color=-1
 	return $im;
 }
 
+// draws the src on dst in a 40x40 box aligned at the bottom left
+function draw_image( $dst, $src ) {
+	$w = imagesx($src);
+	$h = imagesy($src);
+	
+	// draw at the bottom left
+	if ( $w != 40 || $h != 40 ) {
+		imagecopy($dst, $src, 0, 40 - $h, 0, 0, $w, $h);
+	}
+	else {
+		imagecopy($dst, $src, 0, 0, 0, 0, 40, 40);
+	}
+}
+
 function colorize($im, $ca, $cr, $cg, $cb){
 	$w=imagesx($im);
 	$h=imagesx($im);
